<?xml version="1.0" encoding="UTF-8"?>

<databaseChangeLog
  xmlns="http://www.liquibase.org/xml/ns/dbchangelog"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xsi:schemaLocation="http://www.liquibase.org/xml/ns/dbchangelog
         http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-3.0.xsd">

  <!-- DDL SECTION BEGINS -->

  <changeSet author="jeffreya (generated)" id="create-tables-1">
    <createTable tableName="application">
      <column autoIncrement="true" name="application_id" type="BIGINT">
        <constraints primaryKey="true" primaryKeyName="application_pkey"/>
      </column>
      <column name="name" type="VARCHAR(255)"/>
      <column name="hash" type="VARCHAR(255)"/>
    </createTable>
  </changeSet>

  <changeSet author="jeffreya (generated)" id="create-tables-2">
    <createTable tableName="users">
      <column autoIncrement="true" name="user_id" type="BIGINT">
        <constraints primaryKey="true" primaryKeyName="user_pkey"/>
      </column>
      <column name="name" type="VARCHAR(255)"/>
      <column name="hash" type="VARCHAR(255)"/>
      <column name="uuid" type="VARCHAR(255)"/>
    </createTable>
  </changeSet>

  <changeSet author="jeffreya (generated)" id="add_user_to_application-1">
    <createTable tableName="user_app">
      <column autoIncrement="true" name="user_app_id" type="BIGINT">
        <constraints primaryKey="true" primaryKeyName="user_app_pkey"/>
      </column>
      <column name="user_id" type="BIGINT"/>
      <column name="application_id" type="BIGINT"/>
    </createTable>
  </changeSet>

  <changeSet author="mlishman" id="add-user-name-unique-key">
    <addUniqueConstraint columnNames="name"
      tableName="users"/>
  </changeSet>

  <changeSet author="mlishman" id="add-app-name-unique-key">
    <addUniqueConstraint columnNames="name"
      tableName="application"/>
  </changeSet>

  <changeSet author="mlishman" id="add-user-app-unique-key">
    <addUniqueConstraint columnNames="user_id,application_id"
      tableName="user_app"/>
  </changeSet>

  <changeSet author="mlishman" id="create-users-data-table">
    <createTable tableName="users_data">
      <column autoIncrement="true" name="user_data_id" type="BIGINT">
        <constraints primaryKey="true" primaryKeyName="users_data_pkey"/>
      </column>
      <column name="user_id" type="BIGINT"/>
      <column name="nino" type="VARCHAR(9)"/>
    </createTable>
  </changeSet>
  <changeSet author="mlishman" id="users-data-fk1">
    <addForeignKeyConstraint constraintName="users-data-fk1"
      baseColumnNames="user_id"
      baseTableName="users_data"
      referencedColumnNames="user_id"
      referencedTableName="users"/>
  </changeSet>

  <changeSet author="nataliehulse" id="create-trs_access_code-table">
    <createTable tableName="trs_access_code">
      <column autoIncrement="true" name="tac_id" type="BIGINT">
        <constraints primaryKey="true" primaryKeyName="access_pkey"/>
      </column>
      <column name="code" type="VARCHAR(255)"/>
      <column name="phone_number" type="VARCHAR(255)"/>
      <column name="created_date" type="TIMESTAMP" defaultValueComputed="CURRENT_TIMESTAMP"/>
    </createTable>
  </changeSet>

  <changeSet author="nataliehulse" id="create_trs_registration_data_table">
    <createTable tableName="trs_registration_data">
      <column autoIncrement="true" name="trd_id" type="BIGINT">
        <constraints primaryKey="true" primaryKeyName="trd_pkey"/>
      </column>
      <column name="uuid" type="VARCHAR(255)"/>
      <column name="nino" type="VARCHAR(255)"/>
      <column name="surname" type="VARCHAR(255)"/>
      <column name="firstname" type="VARCHAR(255)"/>
      <column name="dob" type="DATE"/>
      <column name="postcode" type="VARCHAR(255)"/>
    </createTable>
  </changeSet>

  <changeSet author="pwhitehead" id="drop-users-data-table">
    <dropTable tableName="users_data"/>
  </changeSet>

  <changeSet author="pwhitehead" id="rename-table-trs-user-data-table">
    <renameTable oldTableName="trs_registration_data" newTableName="trs_user_data"/>
  </changeSet>

  <changeSet author="pwhitehead" id="add-telephone-number-to-trs-user-data">
    <addColumn tableName="trs_user_data">
      <column name="phonenumber" type="VARCHAR(255)"/>
    </addColumn>
  </changeSet>

  <changeSet author="nathulse (generated)" id="add_first_login_to_users">
    <addColumn tableName="users">
      <column name="first_login" type="BOOL" defaultValue="true"/>
    </addColumn>
  </changeSet>

  <changeSet author="nathulse" id="create-user-password-history-table">
    <createTable tableName="user_password_history">
      <column autoIncrement="true" name="uph_id" type="BIGINT">
        <constraints primaryKey="true" primaryKeyName="uph_pkey"/>
      </column>
      <column name="user_id" type="BIGINT"/>
      <column name="name" type="VARCHAR(255)"/>
      <column name="hash" type="VARCHAR(255)"/>
    </createTable>
  </changeSet>
  <changeSet author="nathulse" id="add-user-password_history-fk1">
    <addForeignKeyConstraint constraintName="uph-fk1"
      baseColumnNames="user_id"
      baseTableName="users"
      referencedColumnNames="user_id"
      referencedTableName="users"/>
  </changeSet>

  <changeSet author="nathulse" id="create-reset_email_token">
    <createTable tableName="reset_email_token">
      <column autoIncrement="true" name="ret_id" type="BIGINT">
        <constraints primaryKey="true" primaryKeyName="ret_pkey"/>
      </column>
      <column name="user_id" type="BIGINT"/>
      <column name="token" type="VARCHAR(255)"/>
      <column name="created_date" type="TIMESTAMP" defaultValueComputed="CURRENT_TIMESTAMP"/>
    </createTable>
  </changeSet>
  <changeSet author="nathulse" id="add-reset_email_token-fk1">
    <addForeignKeyConstraint constraintName="ret-fk1"
                             baseColumnNames="user_id"
                             baseTableName="users"
                             referencedColumnNames="user_id"
                             referencedTableName="users"/>
  </changeSet>

  <!-- DDL SECTION ENDS -->

  <!-- DML SECTION BEGINS -->

  <changeSet author="jeffreya" id="add-member-website-application">
    <insert tableName="application">
      <column name="application_id" value="1"/>
      <column name="name" value="fic"/>
      <column name="hash" value="$2a$12$LKsJeUYMG/3YmoOUDC8kGOyR90ma68B8kDlCUeb.dPycnTnRaQkeO"/>
    </insert>
  </changeSet>

  <changeSet author="jeffreya" id="add-user">
    <insert tableName="users">
      <column name="user_id" value="1"/>
      <column name="name" value="sam.jones@email.com"/>
      <column name="hash" value="$2a$12$o97r604auB8BzyTj9WBKOuBIFxyX9JzOTv6j0349Ei/h2JPyrCEsi"/>
      <column name="uuid" value="997bd0eb-cd6e-4829-a507-4d0218cf4e78"/>
    </insert>
  </changeSet>

  <changeSet author="jeffreya" id="add_user_to_application-2">
    <insert tableName="user_app">
      <column name="user_app_id" value="1"/>
      <column name="user_id" value="1"/>
      <column name="application_id" value="1"/>
    </insert>
  </changeSet>

  <changeSet author="jeffreya" id="add-employer-user-1">
    <insert tableName="users">
      <column name="user_id" value="2"/>
      <column name="name" value="admin@nhs.net"/>
      <column name="hash" value="$2a$12$o97r604auB8BzyTj9WBKOuBIFxyX9JzOTv6j0349Ei/h2JPyrCEsi"/>
      <column name="uuid" value="997bd0eb-cd6e-4829-a507-4d0218cf4e74"/>
    </insert>
  </changeSet>

  <changeSet author="jeffreya" id="add-employer-user-2">
    <insert tableName="user_app">
      <column name="user_app_id" value="2"/>
      <column name="user_id" value="2"/>
      <column name="application_id" value="1"/>
    </insert>
  </changeSet>

  <changeSet author="jeffreya" id="add-member-user-1">
    <insert tableName="users">
      <column name="user_id" value="3"/>
      <column name="name" value="sally.smith@email.com"/>
      <column name="hash" value="$2a$12$o97r604auB8BzyTj9WBKOuBIFxyX9JzOTv6j0349Ei/h2JPyrCEsi"/>
      <column name="uuid" value="997bd0eb-cd6e-4829-a507-4d0218cf4e79"/>
    </insert>
  </changeSet>

  <changeSet author="jeffreya" id="add-member-user-2">
    <insert tableName="user_app">
      <column name="user_app_id" value="3"/>
      <column name="user_id" value="3"/>
      <column name="application_id" value="1"/>
    </insert>
  </changeSet>

  <changeSet author="mlishman" id="users-primary-key-seq">
    <sql dbms="postgresql">ALTER SEQUENCE application_application_id_seq RESTART WITH 4;
    </sql>
  </changeSet>

  <changeSet author="mlishman" id="application-primary-key-seq">
    <sql dbms="postgresql">ALTER SEQUENCE users_user_id_seq RESTART WITH 1;
    </sql>
  </changeSet>

  <changeSet author="mlishman" id="user-app-primary-key-seq">
    <sql dbms="postgresql">ALTER SEQUENCE user_app_user_app_id_seq RESTART WITH 6;
    </sql>
  </changeSet>

  <changeSet author="ruben" id="alter-user-create-role-column">
    <addColumn tableName="users">
      <column name="role" type="VARCHAR(255)" />
    </addColumn>
    <addNotNullConstraint
      columnDataType="VARCHAR(255)"
      columnName="role"
      defaultNullValue="STANDARD"
      tableName="users"/>
    <update tableName="users">
      <column name="role" value="ADMIN"/>
      <where>name = 'sam.jones@email.com'</where>
    </update>
    <update tableName="users">
      <column name="role" value="MASTER"/>
      <where>name = 'admin@nhs.net'</where>
    </update>
    <update tableName="users">
      <column name="role" value="STANDARD"/>
      <where>name = 'sally.smith@email.com'</where>
    </update>
  </changeSet>

  <!-- DML SECTION ENDS -->

</databaseChangeLog>


